local bar = _G[...]

local pieces = {}

local function check(source, target)
	--you may now add new defaults at will. ~Goranaws
	if not target then 
		target = {}
	end
	if not source then
		--return
	end
	for key, value in pairs(source) do
		if type(value) == 'table' then
			target[key] =check(value, target[key])
		else
			if (type(value) == 'boolean') then
				if target[key] == nil then
					target[key] = value
				end
 			else
 				target[key] = target[key] or value
 			end
		end
	end
	return target
end

function bar:Load()
	self.components = self.components or {}

	if #self.components == 0 then
		for i, info in pairs(pieces) do
			local component, key = info.func:New(self), info.id

			component.key = key

			if component.defaults then
				self.sets[key] = self.sets[key] or {}
				check(component.defaults, self.sets[key])
				component.sets = self.sets[key]
				self[key] = component
			end

			tinsert(self.components, component)
		end
	end

	for id, component in pairs(self.components) do
		if component.Load then
			component:Load()
		end
	end
end

function bar:NewComponent(name, frameType)
	local component = bar.master:CreateClass(frameType)
 	tinsert(pieces, {id = name, func = component})
 	return component
end

function bar:UpdateComponents()
	if self.components then
		for id, component in pairs(self.components) do
			if component.Layout then
				component:Layout()
			end
		end
	end
end
